"""
使用方法
１．本ファイルとFemtetClassConst.pyを同一フォルダ内に保存する
２．プロジェクトファイルのパスにボディ属性を自動付与したいプロジェクトのフルパスを入力→本ファイル28行目
３．付与するボディ属性名に属性名を入力→本ファイル37行目
    (実際に付与される属性名は”入力した属性名＋番号”になる。ボディ属性名が既に付与されている場合はそのまま。)
４．マクロを実行

注意：このマクロを実行するとファイルを上書き保存しますので、事前にバックアップをお勧めします。
"""

import sys
import win32com.client
#COMクラスのインスタンス作成、マクロ定数(constants)パッケージをインポート
from win32com.client import Dispatch, constants
#FemtetのCOMクラス名を定義したモジュールをインポート
from FemtetClassConst import FemtetClassName as const

#Main関数
def FemtetMain():
    global Femtet                    #Femtet変数は別関数で利用したいのでglobal変数として定義する
    Femtet = Dispatch(const.CFemtet) #CFemtetクラスのインスタンス作成


    #------- 指定されたプロジェクトを開く -------
    
    #プロジェクトファイルのフルパス 
    ProjectFilePath = R"C:\temp\test.femprj"
    
    if Femtet.LoadProject(ProjectFilePath, True) == False: 
        Femtet.ShowLastError
    
    
    #------- ボディ属性の指定されていないボディに属性名を自動付与 -------
    
    #付与するボディ属性名
    BtrName = "DM"
    
    name_index = 0
    iMax = Femtet.Gaudi.BodyNum
    for index in range(iMax):
        Body = Femtet.Gaudi.Body(Femtet.Gaudi.BodyKey(index))   #-----指定されたプロジェクトに定義された全ボディをひとつずつ取得
        if Body.BodyAttributeName == "":                        #-----ボディ属性が定義されていないボディを探す
            name = BtrName + str(name_index)                    #-----ボディ属性名作成(セルに指定されたボディ属性名＋番号)
            Body.SetName(name,"")                               #-----ボディ属性名付与(材料定数名は定義していない)
            name_index += 1                                     #-----ボディ属性名に付与する番号をカウントアップ


    #------- プロジェクトを上書き保存 -------
    if Femtet.SaveProject(ProjectFilePath, True) == False:
        FEMTET.ShowLastError

#Main関数の実行
if __name__ == '__main__':
    FemtetMain()
